/**
 * 公共post请求
 * @param url
 * @param data
 * @returns {Promise<*>}
 */
async function postRequest(url, data = {}) {
    return new Promise((resolve, reject) => {
        $.ajax({
            url: url,
            type: "POST",
            dataType: "json",
            data: data,
            success: (res) => {
                resolve(res)
            },
            error: (err) => {
                reject(err)
            }
        })
    })
}

/**
 * 公共get请求
 * @param url
 * @param data
 * @returns {Promise<*>}
 */
async function getRequest(url, data = {}) {
    return new Promise((resolve, reject) => {
        $.ajax({
            url: url,
            type: "GET",
            dataType: "json",
            data: data,
            success: (res) => {
                resolve(res)
            },
            error: (err) => {
                reject(err)
            }
        })
    })
}

/**
 * 跳转页面
 * @param param
 * @param type
 * @param url
 */
function parentIframeToUrl(param, type = 1, url = '')
{
    if(!url) url = window.location.href;
    param['type'] = type;
    window.parent.postMessage(param,url);
}

function handleTree(data, pid = 0, parentField = 'pid', valueField = 'id', labelField = 'title' )
{
    let type = typeof data;
    if(type != 'array' && type != 'object')
        return [];
    let res = [];
    data.forEach(v =>{
        if(v[parentField] == pid){
            let info = {value:v[valueField],label:v[labelField]}, child = handleTree(data,v[valueField]);
            if(child.length > 0) info.children = child;
            res.push(info);
        }
    });

    return res;
}